#pragma once

#include <cmath>
#include <vector>
#include "vect.h"
#include "global.h"

using namespace std;

void calcBaryCoords();
vect2d perp(const vect2d &a);

template <int n>
double power(double x)
{
	if (n == 1)
		return x;
	else if (n == 2)
		return x*x;
	else if (n == 3)
		return x*x*x;
	else if (n == 4)
		return x*x*x*x;
	else if (n == -1)
		return 1.0/(x);
	else if (n == -2)
		return 1.0/(x*x);
	else if (n == -3)
		return 1.0/(x*x*x);
	else if (n == -4)
		return 1.0/(x*x*x*x);
	else
		return pow(x, n);
}

#define Power(a,b) power<b>(a)
#define Log(a) log(a)




// bary_linear.h
void calcBary_Alpha1(double *bary, vect2d &x, vector<vect2d> &pv, vector<vect2i> &p);
void calcBary_Alpha2(double *bary, vect2d &x, vector<vect2d> &pv, vector<vect2i> &p);
void calcBary_Alpha3(double *bary, vect2d &x, vector<vect2d> &pv, vector<vect2i> &p);


