#pragma once

#define SAVE_OBJ_AND_EXIT

#include <vector>
#include <string>
#include <list>
#include "vect.h"
#include "image.h"
#include "array2d.h"

using namespace std;

struct SDL_Surface;

enum Method
{
	points_linear, // 0
	wachspress, // 1
	lines_linear_old, // 2
	lines_linear, // 3
	lines_quad, // 4 
	mean_value, // 5
	harmonic, // 6
	maximum_entropy, // 7
	from_file, // 8

	// begin of Kuiyu 11/23/2010
	pos_gordon_wixom, // 9
	// end of Kuiyu 11/23/2010

	method_num
};

enum WeightFunction
{
	length_difference,
	reciprocal_distance,
};

struct Curve
{
	bool closed;
	list<vect2f> pts;
};



// begin of Kuiyu 11/23/2010
#include "kuiyuBarycentric/polygon.hpp"
#include "kuiyuBarycentric/matrix.hpp"
#include "kuiyuBarycentric/basic.h"
#include "kuiyuBarycentric/barycentric.h"

//#define inputPolygon "ConcavePoly-sub"
//#define inputPolygon "JoeConcave-sub"
// end of Kuiyu 11/23/2010

struct Global
{
	Global();

	vector<vect2d> poly[2]; /// vertices of the control, deformed polys (NOT SURE WHAT THE DIFFERENCE IS BETWEEN these and Poly, deformPoly is)

	// begin of Kuiyu 11/23/2010
	string inputPolygon;
	unsigned int nSubd;
	CPoly Poly;
	CPoly* subdPoly;
	CPoly deformPoly;
	CPoly* deformSubPoly;
	CMatrix* subdMatrix;
	CMatrix* bsplineWeight;
	double curve_distance_epsilon;
	// end of Kuiyu 11/23/2010

	Image *img;

	SDL_Surface* screen;

	float time;
	float frame_time;
	float frame_rate() {return 1000.0 / frame_time;}

	int scr_width, scr_height;
	bool fullscreen;
    bool running; // set false to quit the game

	unsigned int sel_poly;
	unsigned int sel_vert;
	unsigned int sel_type; /// 0 == vertex, 1 == normal

	bool draw_surface; // otherwise, draw image
	bool draw_contours;
	bool use_basis_values; // draw a function using height_vals, deriv_vals
	float height_scale;

	Method method;
	WeightFunction weight_function;
	int order;
	int deriv;
	int alpha;

	vector<vector<vect2f>> contours;
	vector<vector<vect2i>> contours_edges;
	vector<vector<Curve>> curves;

	vector<vect2i> tri_edges;
	vector<vect3i> tri_tris;
	vector<vect2d> tri_pt_pos;
	vector<double> tri_pt_barys0; // the final bary coordinates
	vector<double> tri_pt_barys;
	vector<bool> tri_pt_border;
};

extern Global g;
