#ifndef _BARYCENTRIC_
#define _BARYCENTRIC_

#include "point.hpp"
#include "vector.hpp"
#include "matrix.hpp"
#include "polygon.hpp"
#include "quadtree.hpp"


// Compute Barycentric Basis Functions for each vertex of the polygon Poly
CMatrix* BaseFunctions( const vector<CPoint>& sample, const CPoly& Poly, unsigned int nSubd );

//'Barycentric' compute the Barycentric coordinate for a point on the boundary or in the interior of an arbitrary polygon
CVector*  Barycentric( QUADTREE::Quadtree& quadTree, const CPoint& X, const CPoly& Poly );

// Compute Barycentric Basis Functions for each vertex of the polygon Poly
CMatrix* approBaseFunctions( const vector<CPoint>& sample, const CPoly& Poly, unsigned int nSubd );

//'Barycentric' compute the Barycentric coordinate for a point on the boundary or in the interior of an arbitrary polygon
CVector*  approBarycentric( QUADTREE::Quadtree& quadTree, const CPoint& X, unsigned int PolySize, const CPoly& subdPoly, const CMatrix& bsplineWeight );

CVector* getWeightforOriginalPolygon( CVector* weightSubd, unsigned int PolySize, unsigned int subdPolySize, const CMatrix& bsplineWeight );

#endif